unit WinAdcSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc, Mask;

type
  TWinAdcSettings = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    MainBattery_C1: TEdit;
    Label2: TLabel;
    ADC_Main_bat: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    Label4: TLabel;
    MainBattery_C2: TEdit;
    Label5: TLabel;
    MainBattery_C3: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    ADC_Second_bat: TLabel;
    Label9: TLabel;
    ADC_Third_bat: TLabel;
    Label8: TLabel;
    RSSI_Volt: TLabel;
    Label10: TLabel;
    AIR_Volt: TLabel;
    Label11: TLabel;
    CUR_Volt: TLabel;
    Label12: TLabel;
    Cur_cur: TLabel;
    Label13: TLabel;
    Cur_used: TLabel;
    Label14: TLabel;
    SecondBattery_C: TEdit;
    Label15: TLabel;
    ThirdBattery_C: TEdit;
    Label16: TLabel;
    AirSens_C: TEdit;
    Label17: TLabel;
    AIR_Speed_Koef_K: TEdit;
    Label18: TLabel;
    AIR_Speed_Koef_B: TEdit;
    Label19: TLabel;
    Air_Speed_Zero_Level: TEdit;
    Label20: TLabel;
    RssiSens_C: TEdit;
    Label21: TLabel;
    Rssi_Sens_Max_V: TEdit;
    Label22: TLabel;
    Rssi_Sens_Min_V: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    CurrentSens_K: TEdit;
    CurrentSens_C: TEdit;
    Label25: TLabel;
    CurrentSens_B: TEdit;
    SpeedButton1: TSpeedButton;
    Label26: TLabel;
    AIR_Speed: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      InitValues: TStringList;
      procedure LoadVariable(k,v: string);
      procedure SetControlValue(tc: TControl; v: string);
      function  GetControlValue(tc: TControl): string;
      function  FindControl(cn: string): TControl; 
      procedure ApplyChanges;

  end;

var
  WinAdcSettings: TWinAdcSettings;

implementation

uses MAIN, WinOSDControlsUnit;

{$R *.dfm}

procedure TWinAdcSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;


procedure TWinAdcSettings.FormCreate(Sender: TObject);
var
  s,k,v: string;
begin
  InitValues:= TStringList.Create;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat adc_settings'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else continue;
    end;
  end;
  MainForm.AddToOutput('mon on adc_values'+#13#10);
end;


procedure TWinAdcSettings.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinAdcSettings.ApplyChanges;
var
  i: integer;
  k,v: string;
   tc,tc_x,tc_y: TControl;
   ControlName: string;
   new_v,x,y,new_xv,new_yv: string;
begin
  for i:=0 to InitValues.Count-1 do begin
    k:=InitValues.Names[i];
    v:=InitValues.ValueFromIndex[i];
    tc:=FindControl(k);
    if(tc<>nil) then begin
      new_v:=GetControlValue(tc);
      if (new_v<>'') and (new_v <> v) then begin
         MainForm.AddToOutput('set '+k+' '+ new_v +#13#10);
         InitValues.Values[k]:=new_v;
      end;
    end;
  end;
end;

function TWinAdcSettings.FindControl(cn: string): TControl;
begin
    Result:=Panel2.FindChildControl(cn);
    if Result = nil then begin
      exit;
    end;
end;

function TWinAdcSettings.GetControlValue(tc: TControl): string;
begin

  Result:='';
  if tc.ClassName='TEdit' then begin
     Result:=(tc as TEdit).Text;
     Result:=StringReplace(Result,',','.',[rfReplaceAll]);
  end;
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;

  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;

  if tc.ClassName='TCheckBox' then begin
     Result:='0';
     if (tc as TCheckBox).Checked then Result:='1';
  end;

end;

procedure TWinAdcSettings.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  tc:=FindControl(k);
  if(tc<>nil) then begin
    SetControlValue(tc,v);
    InitValues.Values[k]:=v;
  end;
end;

procedure TWinAdcSettings.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TEdit' then begin
     (tc as TEdit).Text := v;
  end;


  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;

  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;

  if tc.ClassName='TCheckBox' then begin
     if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
  end;
end;

procedure TWinAdcSettings.BitBtn3Click(Sender: TObject);
begin
  ApplyChanges;
end;

procedure TWinAdcSettings.BitBtn1Click(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;

procedure TWinAdcSettings.FormDestroy(Sender: TObject);
begin
  MainForm.AddToOutput('mon off adc_values'+#13#10);
  InitValues.Free;
  WinAdcSettings := nil;
end;

procedure TWinAdcSettings.Timer1Timer(Sender: TObject);
var
   s: string;
   i: integer;
begin
  s:=MainForm.ADC_mon;
  i:=Pos('BAT1=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     ADC_Main_bat.Caption:=Copy(s,1,i);
  end;

  i:=Pos('BAT2=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     ADC_Second_bat.Caption:=Copy(s,1,i);
  end;

  i:=Pos('BAT3=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     ADC_Third_bat.Caption:=Copy(s,1,i);
  end;

  i:=Pos('RSSI=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     RSSI_Volt.Caption:=Copy(s,1,i);
  end;

  i:=Pos('AIR=',s);
  if i>0 then begin
     Delete(s,1,i+3);
     i:=pos(' ',s);
     AIR_Volt.Caption:=Copy(s,1,i);
  end;


  i:=Pos('CurV=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     CUR_Volt.Caption:=Copy(s,1,i);
  end;

  i:=Pos('CurI=',s);
  if i>0 then begin
     Delete(s,1,i+4);
     i:=pos(' ',s);
     Cur_cur.Caption:=Copy(s,1,i);
  end;

  i:=Pos('Cur_Used=',s);
  if i>0 then begin
     Delete(s,1,i+8);
     i:=pos(' ',s);
     Cur_Used.Caption:=Copy(s,1,i);
  end;


  i:=Pos('AIR_Speed=',s);
  if i>0 then begin
     Delete(s,1,i+9);
     AIR_Speed.Caption:=Copy(s,1,Length(s));
  end;

end;

procedure TWinAdcSettings.SpeedButton1Click(Sender: TObject);
begin
  MainForm.AddToOutput('start current_integ'+#13#10);
end;

end.



