unit WinBatSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc, Mask;

type
  TWinBatSettings = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label2: TLabel;
    Main_Battery_Full_V: TEdit;
    Label3: TLabel;
    Main_Battery_Empty_V: TEdit;
    Label4: TLabel;
    Main_Battery_Full_C: TEdit;
    Label5: TLabel;
    Second_Battery_Full_V: TEdit;
    Second_Battery_Empty_V: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Third_Battery_Full_V: TEdit;
    Third_Battery_Empty_V: TEdit;
    Label8: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      InitValues: TStringList;
      procedure LoadVariable(k,v: string);
      procedure SetControlValue(tc: TControl; v: string);
      function  GetControlValue(tc: TControl): string;
      function  FindControl(cn: string): TControl; 
      procedure ApplyChanges;
  end;

var
  WinBatSettings: TWinBatSettings;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinBatSettings.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWinBatSettings.FormDestroy(Sender: TObject);
begin
  InitValues.Free;
  WinBatSettings:=nil;
end;

procedure TWinBatSettings.FormCreate(Sender: TObject);
var
  s,k,v: string;
begin
  InitValues:= TStringList.Create;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat batteries'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else continue;
    end;
  end;
end;

procedure TWinBatSettings.BitBtn1Click(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;

procedure TWinBatSettings.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinBatSettings.ApplyChanges;
var
  i: integer;
  k,v: string;
   tc,tc_x,tc_y: TControl;
   ControlName: string;
   new_v,x,y,new_xv,new_yv: string;
begin
  for i:=0 to InitValues.Count-1 do begin
    k:=InitValues.Names[i];
    v:=InitValues.ValueFromIndex[i];
    tc:=FindControl(k);
    if(tc<>nil) then begin
      new_v:=GetControlValue(tc);
      if (new_v<>'') and (new_v <> v) then begin
         MainForm.AddToOutput('set '+k+' '+ new_v +#13#10);
         InitValues.Values[k]:=new_v;
      end;
    end;
  end;
end;

function TWinBatSettings.FindControl(cn: string): TControl;
begin
  Result:=Panel2.FindChildControl(cn);
  if Result = nil then begin
    exit;
  end;
end;

function TWinBatSettings.GetControlValue(tc: TControl): string;
begin
  Result:='';
  if tc.ClassName='TEdit' then begin
     Result:=(tc as TEdit).Text;
     Result:=StringReplace(Result,',','.',[rfReplaceAll]);
  end;
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;
  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;
  if tc.ClassName='TCheckBox' then begin
     Result:='0';
     if (tc as TCheckBox).Checked then Result:='1';
  end;
end;

procedure TWinBatSettings.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  tc:=FindControl(k);
  if(tc<>nil) then begin
    SetControlValue(tc,v);
    InitValues.Values[k]:=v;
  end;
end;

procedure TWinBatSettings.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TEdit' then begin
     (tc as TEdit).Text := v;
  end;
  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;
  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;
  if tc.ClassName='TCheckBox' then begin
     if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
  end;
end;

procedure TWinBatSettings.BitBtn3Click(Sender: TObject);
begin
  ApplyChanges;
end;

end.
